
#ifndef __MODEL__
#define __MODEL__

#include "utool.hh"
#include "stateSpace.hh"
#include "manager.hh"

UBDD R(const StateSpace& S);

struct Model {

  const StateSpace& S;
  Manager& Man;

  const UBDD R;

  inline UBDD the_R() const { Man.start("R"); UBDD R = ::R(S) /* & S.States & S._States */; Man.end(R); return R; }

         UBDD* AP_pointer(const string& name); // needed by the lexer - yylval is UBDD*
  inline UBDD  AP        (const string& name) { return *(AP_pointer(name)); }

public:
  inline Model(const StateSpace& S, Manager& Man): S(S), Man(Man), R(the_R()) {}

#include "R-APs.hpp"

};

#endif
